> npm install -g hacker-job-trends

## hacker-job-trends

As we know, an "Ask HN: Who is Hiring?"([example](https://news.ycombinator.com/item?id=17442187)) post will occur at hackernews every month. It is interesting to scan the post because it helps you to get a feeling about what is happening in tec related business. This repo aims to help you keep up with how the tec job requirements/used tools/kind/... evolve.

## How

1.  Get historical "Who is hiring" posts on HackerNews
2.  Analyes the keyword count history

## Examples

#### remote job trends:

```bash
$ hjt 'remote' - 'not remote' - 'no remote'

 397.00 ┼                                                                                            ╭─╮
 371.20 ┤                                                                                     ╭──╮╭╮ │ │
 345.40 ┤                                                                                ╭─╮  │  ╰╯╰╮│ │╭─
 319.60 ┤                                                                               ╭╯ │ ╭╯     ││ ╰╯
 293.80 ┤                                                                    ╭╮  ╭╮   ╭╮│  ╰╮│      ╰╯
 268.00 ┤                                                                    ││  ││╭╮ │╰╯   ╰╯
 242.20 ┤                                                      ╭╮     ╭╮╭─╮  │╰╮╭╯╰╯╰─╯
 216.40 ┤                                                     ╭╯│ ╭╮  │││ ╰──╯ ╰╯
 190.60 ┤                                                  ╭╮ │ ╰─╯│ ╭╯││
 164.80 ┤                                          ╭╮      ││╭╯    │ │ ╰╯
 139.00 ┤                                       ╭╮╭╯│  ╭╮ ╭╯╰╯     │╭╯
 113.20 ┤                                    ╭╮╭╯││ ╰╮ ││╭╯        ╰╯
  87.40 ┤                          ╭╮  ╭╮╭─╮ │╰╯ ╰╯  ╰─╯╰╯
  61.60 ┤╭╮ ╭─╮ ╭╮   ╭────╮╭╮╭──╮╭─╯╰──╯╰╯ ╰─╯
  35.80 ┼╯│╭╯ ╰─╯╰───╯    ╰╯╰╯  ╰╯
  10.00 ┤ ╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

#### blockchain trends

```
$ hjt 'ethereum' + 'blockchain' + 'bitcoin' + 'solidity' + 'smart contract'

 137.00 ┼                                                                                       ╭╮
 127.87 ┤                                                                                 ╭╮    ││
 118.73 ┤                                                                                 ││    │╰╮
 109.60 ┤                                                                                 │╰╮ ╭╮│ │  ╭╮
 100.47 ┤                                                                                 │ │ │││ ╰╮ ││
  91.33 ┤                                                                               ╭─╯ │╭╯╰╯  ╰╮│╰╮
  82.20 ┤                                                                               │   ╰╯      ││ │
  73.07 ┤                                                                               │           ╰╯ │
  63.93 ┤                                                                               │              │
  54.80 ┤                                                                               │              │╭─
  45.67 ┤                                                                        ╭─╮    │              ││
  36.53 ┤                                                                    ╭─╮ │ │ ╭─╮│              ╰╯
  27.40 ┤                                          ╭╮                        │ │╭╯ │╭╯ ││
  18.27 ┤                                          ││      ╭─╮╭╮             │ ╰╯  ╰╯  ││
   9.13 ┤                               ╭╮     ╭─╮╭╯╰─╮╭╮ ╭╯ ╰╯╰────╮ ╭╮ ╭───╯         ╰╯
   0.00 ┼───────────────────────────────╯╰─────╯ ╰╯   ╰╯╰─╯         ╰─╯╰─╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01

```

#### java trends:

```bash
$ hjt 'java' - 'javascript'

 190.00 ┤                                                                        ╭╮
 178.00 ┤                                                                        ││
 166.00 ┤                                                                        ││             ╭╮
 154.00 ┤                                                                        ││      ╭─╮    ││
 142.00 ┤                                                                        ││      │ │    ││
 130.00 ┤                                                      ╭╮ ╭╮          ╭╮ ││ ╭╮╭╮╭╯ │ ╭──╯│   ╭──╮
 118.00 ┤                                                     ╭╯│ ││       ╭╮╭╯│ ││ │╰╯╰╯  ╰╮│   ╰╮╭╮│  ╰╮
 106.00 ┤                                          ╭╮      ╭──╯ ╰╮││  ╭╮╭─╮│││ ╰╮│╰─╯       ╰╯    ╰╯││   ╰
  94.00 ┤                                         ╭╯│    ╭╮│     │││  │││ ╰╯╰╯  ╰╯                  ╰╯
  82.00 ┤                          ╭╮  ╭╮ ╭╮   ╭╮ │ │╭╮╭╮│╰╯     ╰╯│ ╭╯╰╯
  70.00 ┤            ╭╮            ││  ││╭╯│   │╰╮│ ││││││         │ │
  58.00 ┤            ││      ╭╮  ╭╮│╰─╮│││ │ ╭╮│ ╰╯ ╰╯╰╯││         │ │
  46.00 ┤          ╭╮││╭╮    ││  │╰╯  ╰╯╰╯ ╰╮│╰╯        ╰╯         ╰╮│
  34.00 ┤  ╭─────╮╭╯││╰╯╰╮╭──╯╰──╯          ││                      ╰╯
  22.00 ┤╭╮│     ╰╯ ╰╯   ╰╯                 ╰╯
  10.00 ┼╯╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

#### javascript trends:

```bash
$ hjt 'javascript' + ' js '

 264.00 ┼                                                     ╭╮
 246.67 ┤                                                     ││                 ╭╮       ╭╮
 229.33 ┤                                                     ││              ╭╮ ││ ╭╮   ╭╯│
 212.00 ┤                                              ╭╮  ╭╮ │╰╮     ╭╮╭╮    ││ ││ ││   │ │ ╭╮      ╭╮
 194.67 ┤                                         ╭─╮  ││  │╰╮│ │ ╭╮  │││╰╮  ╭╯│ │╰─╯│  ╭╯ ╰╮││╭─╮   ││
 177.33 ┤                                         │ │  ││  │ ╰╯ ╰─╯│ ╭╯╰╯ ╰──╯ │ │   ╰──╯   ╰╯╰╯ ╰╮╭╮││
 160.00 ┤                           ╭╮   ╭╮       │ ╰─╮││╭╮│       │ │         │ │                ││││╰╮╭╮
 142.67 ┤                           ││   ││     ╭╮│   ╰╯││╰╯       │ │         ╰─╯                ╰╯╰╯ ╰╯╰
 125.33 ┤                           ││╭─╮│╰╮ ╭──╯││     ││         │ │
 108.00 ┤                          ╭╯╰╯ ││ │╭╯   ╰╯     ╰╯         │╭╯
  90.67 ┤                  ╭╮╭╮   ╭╯    ││ ╰╯                      ╰╯
  73.33 ┤     ╭╮      ╭─╮╭─╯╰╯╰───╯     ╰╯
  56.00 ┤  ╭──╯╰─╮╭─╮╭╯ ╰╯
  38.67 ┤  │     ╰╯ ╰╯
  21.33 ┼─╮│
   4.00 ┤ ╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

### nodejs trends

```bash
$ hjt 'nodejs' + 'node.js'

 108.00 ┼                                                                                ╭╮     ╭╮
 100.80 ┤                                                                                ││     ││
  93.60 ┤                                                     ╭╮              ╭╮ ╭─╮   ╭╮│╰╮╭─╮ ││   ╭╮
  86.40 ┤                                                    ╭╯│              ││ │ │╭╮╭╯││ ││ ╰╮││   ││
  79.20 ┤                                         ╭╮         │ ╰──╮       ╭╮ ╭╯│ │ ││││ ││ ╰╯  │││ ╭╮│╰╮╭╮
  72.00 ┤                                         ││       ╭╮│    │      ╭╯│ │ │ │ ││││ ││     ╰╯╰╮│││ ││╰
  64.80 ┤                                         │╰╮  ╭╮  │││    ╰╮   ╭─╯ ╰─╯ ╰╮│ ││╰╯ ╰╯        ╰╯╰╯ ╰╯
  57.60 ┤                                         │ │  ││╭╮│╰╯     │  ╭╯        ╰╯ ╰╯
  50.40 ┤                                       ╭╮│ │  │││╰╯       │ ╭╯
  43.20 ┤                              ╭╮      ╭╯││ │╭╮│╰╯         │ │
  36.00 ┤                              ││╭╮  ╭─╯ ││ ╰╯╰╯           ╰╮│
  28.80 ┤                              │││╰╮ │   ╰╯                 ││
  21.60 ┤      ╭╮ ╭╮ ╭─╮╭╮ ╭╮  ╭╮╭─────╯││ │ │                      ╰╯
  14.40 ┤    ╭╮│╰─╯╰─╯ ╰╯╰─╯╰──╯╰╯      ╰╯ ╰╮│
   7.20 ┤╭╮╭─╯╰╯                            ╰╯
   0.00 ┼╯╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

#### react trends

```bash
$ hjt react

 386.00 ┼                                                                                       ╭╮ ╭╮
 360.27 ┤                                                                                ╭─╮    ││ ││╭─╮
 334.53 ┤                                                                                │ │  ╭─╯╰─╯╰╯ │╭─
 308.80 ┤                                                                                │ ╰╮╭╯        ││
 283.07 ┤                                                                     ╭╮ ╭╮ ╭╮ ╭─╯  ││         ╰╯
 257.33 ┤                                                                     ││ ││ │╰╮│    ╰╯
 231.60 ┤                                                                     ││ │╰─╯ ╰╯
 205.87 ┤                                                                  ╭╮╭╯│ │
 180.13 ┤                                                               ╭──╯╰╯ ╰╮│
 154.40 ┤                                                             ╭╮│       ╰╯
 128.67 ┤                                                            ╭╯╰╯
 102.93 ┤                                                     ╭────╮ │
  77.20 ┤                                                  ╭──╯    ╰─╯
  51.47 ┤                                                 ╭╯
  25.73 ┤                                      ╭╮  ╭╮╭────╯
   0.00 ┼──────────────────────────────────────╯╰──╯╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

#### python trends

```bash
$ hjt python

 328.00 ┼                                                                                ╭╮
 306.27 ┤                                                                                │╰╮   ╭╮  ╭╮╭╮
 284.53 ┤                                                                        ╭╮ ╭╮ ╭─╯ │ ╭─╯╰╮ ││││
 262.80 ┤                                                                     ╭╮ │╰╮││ │   ╰╮│   ╰─╯╰╯╰───
 241.07 ┤                                                     ╭──╮         ╭╮ ││ │ ││╰╮│    ╰╯
 219.33 ┤                                                   ╭╮│  │       ╭─╯│╭╯╰╮│ ╰╯ ╰╯
 197.60 ┤                                         ╭─╮  ╭╮╭╮╭╯╰╯  ╰╮      │  ╰╯  ││
 175.87 ┤                                         │ │  │││││      ╰╮ ╭───╯      ╰╯
 154.13 ┤                                ╭╮       │ │  │││╰╯       │ │
 132.40 ┤                              ╭╮││  ╭╮╭─╮│ ╰──╯││         │ │
 110.67 ┤                          ╭╮  │││╰╮ │╰╯ ╰╯     ╰╯         ╰─╯
  88.93 ┤                ╭╮╭╮╭──╮  │╰──╯││ ╰╮│
  67.20 ┤       ╭╮ ╭╮╭─╮╭╯││╰╯  ╰──╯    ╰╯  ╰╯
  45.47 ┤  ╭────╯╰─╯││ ╰╯ ╰╯
  23.73 ┼─╮│        ╰╯
   2.00 ┤ ╰╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

#### golang trends

```bash
$ hjt golang

  50.00 ┼                                                                                      ╭╮
  46.67 ┤                                                                                      ││    ╭─╮╭╮
  43.33 ┤                                                                                      ││   ╭╯ │││
  40.00 ┤                                                                ╭╮                   ╭╯│╭╮╭╯  ╰╯│
  36.67 ┤                                                                ││   ╭╮         ╭╮╭╮ │ ╰╯││     │
  33.33 ┤                                                                ││╭╮╭╯│     ╭╮  ││││ │   ││     ╰
  30.00 ┤                                                                │││╰╯ │  ╭╮╭╯╰╮ ││││ │   ╰╯
  26.67 ┤                                                               ╭╯││   ╰╮╭╯││  ╰╮│╰╯│ │
  23.33 ┤                                                               │ ╰╯    ││ ││   ││  ╰─╯
  20.00 ┤                                                        ╭╮     │       ╰╯ ╰╯   ╰╯
  16.67 ┤                                                     ╭╮ │╰─╮ ╭─╯
  13.33 ┤                                                  ╭╮ ││ │  │ │
  10.00 ┤                                     ╭─╮          ││ ││╭╯  ╰─╯
   6.67 ┤                                ╭╮   │ ╰╮╭─╮ ╭╮╭╮ │╰─╯╰╯
   3.33 ┤                                │╰╮  │  ╰╯ ╰─╯╰╯╰─╯
   0.00 ┼────────────────────────────────╯ ╰──╯
        :
        ┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──────────┼┼──
       2011-01     2012-01     2013-01     2014-01     2015-01     2016-01     2017-01     2018-01     2019-01
```

## npm package

```bash
# install package (node version > 10.0.0)
npm install -g hacker-job-trends

# see match count history on hackernews who is hiring post
hjt 'python'

# match multiple keyword and a count them together
hjt ' js ' + 'javascript'

# match multiple keywords but you want to do a subtraction operation
hjt 'remote' - 'no remote' - 'not remote'

# If you want the trends with count of keywords related to number of posts, add the option `--relative`
hjt react --relative
```

## Contributing

### 1. Add new useful trend graph

By installing the npm module and generating new interesting chart and open a PR for the `README.md`

### 2. Add new who is hiring link

1.  Fork the repo and `npm install`
2.  Add new "who is hiring" post url on [HN-who-is-hiring-monthly.md](./HN-who-is-hiring-monthly.md)
3.  `npm run updateContents` and make a PR

## Best search pattern for searching monthly "who is hiring" on hackernews

```bash
# Google:
Ask HN: Who is Hiring? "November 2011" site:https://news.ycombinator.com/
```

> [Donate with bitcoin](https://getcryptoo.github.io/)
